import {GLOBAL_PARAMS, SerializableItem} from "../helper/serializableitem";
import { Graph } from "./graph";
import { GraphElement } from "./graphelement";

const NODE_TYPE_PARAMS = ["name", "color", ...GLOBAL_PARAMS];

export class NodeType extends GraphElement {
    public name: string;
    public color: string;

    serialize(): any {
        return this.serializeProperties(NODE_TYPE_PARAMS);
    }

    public delete(): boolean {
        // TODO: Implement
        throw new Error("Function \"delete()\" has not been implemented.");
    }

    public add(graph: Graph = this.graph): boolean {
        // TODO: Implement
        throw new Error("Function \"add(graph)\" has not been implemented.");
    }

    public getCleanInstance(): any {
        return this.serialize();
    }
}